

 function blocresult = blcthre3d(im, blksz, fun)
  
  if isempty(blksz)
    blksz = size(im);
  end
% image size
imsz = size(im);

% starting points
sr = 1:blksz(1):imsz(1);
sc = 1:blksz(2):imsz(2);
ss = 1:blksz(3):imsz(3);

% end points
er = sr + blksz(1) - 1;
ec = sc + blksz(2) - 1;
es = ss + blksz(3) - 1;


% number of blocks in each dimension
NBR = length(sr);
NBC = length(sc);
NBS = length(ss);


%compute size of vectorized block
szbl = blksz(1) * blksz(2) * blksz(3);

%vector matrix
blocvec = zeros(szbl, (imsz(1)/blksz(1))*(imsz(2)/blksz(2))*(imsz(3)/blksz(3)));

index1 = 1;

    % iterate all image blocks
    for I = 1:NBR
        for J = 1:NBC
            for K = 1:NBS
                % process current image block
                PRBLK = fun(im(...
                    sr(I):er(I), ...
                    sc(J):ec(J), ...
                    ss(K):es(K) ...
                    ));
         
       blocvec(:, index1) = PRBLK;
           index1 = index1 + 1;
            end
        end
    end
    blocsin= sum(blocvec,2);
blocresult = fd(blocsin,blksz(1),blksz(2),blksz(3));
  end